%This M-Function was created automatically by PSG Toolbox.
%See section "Special Subroutines in Toolbox -> User Subroutine in Toolbox" in PSG Help Manual.
%
%Input variables:
%
%Inputs                      PSG Type    PSG Object             Location in Problem Statement                       Class
%matrix_new_1_data           data        matrix_new_1           10*pm_pen_g(parameter_alpha1,matrix_new_1)          double
%matrix_new_1_vars           vars        matrix_new_1           10*pm_pen_g(parameter_alpha1,matrix_new_1)          cell
%matrix_new_0_data           data        matrix_new_0           pm_pen(parameter_alpha1,matrix_new_0)               double
%matrix_new_0_vars           vars        matrix_new_0           pm_pen(parameter_alpha1,matrix_new_0)               cell
%matrix_0_data               data        matrix_0               pm_pen(parameter_alpha2,L(matrix_0)-L(matrix_1))    double
%matrix_0_vars               vars        matrix_0               pm_pen(parameter_alpha2,L(matrix_0)-L(matrix_1))    cell
%matrix_1_data               data        matrix_1               pm_pen(parameter_alpha2,L(matrix_0)-L(matrix_1))    double
%matrix_1_vars               vars        matrix_1               pm_pen(parameter_alpha2,L(matrix_0)-L(matrix_1))    cell
%point_problem_start_data    data        point_problem_start    n/a                                                 double
%point_problem_start_vars    vars        point_problem_start    n/a                                                 cell
%alpha1                      data        parameter_alpha1       10*pm_pen_g(parameter_alpha1,matrix_new_1)          double
%                                                               pm_pen(parameter_alpha1,matrix_new_0)
%alpha2                      data        parameter_alpha2       pm_pen(parameter_alpha2,L(matrix_0)-L(matrix_1))    double
%alpha_op                    data        parameter_alpha_op     Constraint: <= parameter_alpha_op                   double
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


function [solution_str,outargstruc_arr] = Optimization_subroutine(matrix_new_1_data,matrix_new_1_vars,matrix_new_0_data,matrix_new_0_vars,matrix_0_data,matrix_0_vars,matrix_1_data,matrix_1_vars,point_problem_start_data,point_problem_start_vars,alpha1,alpha2,alpha_op)

%Pack data to PSG structure:
count = 0;
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_new_1',matrix_new_1_data,matrix_new_1_vars,[],[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_new_0',matrix_new_0_data,matrix_new_0_vars,[],[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_0',matrix_0_data,matrix_0_vars,[],[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_1',matrix_1_data,matrix_1_vars,[],[]);
count = count+1;
iargstruc_arr(count) = point_pack('point_problem_start',point_problem_start_data,point_problem_start_vars);
%Define problem statement:
problem_statement = sprintf('%s\n',...
'minimize',...
'  10*pm_pen_g(parameter_alpha1,matrix_new_1)',...
'  pm_pen(parameter_alpha1,matrix_new_0)',...
'Constraint: <= parameter_alpha_op',...
'  pm_pen(parameter_alpha2,L(matrix_0)-L(matrix_1))',...
'Solver: init_point = point_problem_start',...
' ');
%Change parameters with their values in problem statement:
problem_statement = strrep(problem_statement,'parameter_alpha_op',num2str(alpha_op));
problem_statement = strrep(problem_statement,'parameter_alpha1',num2str(alpha1));
problem_statement = strrep(problem_statement,'parameter_alpha2',num2str(alpha2));

%Optimize problem using mpsg_solver function:
[solution_str, outargstruc_arr] = mpsg_solver(problem_statement, iargstruc_arr);
results = psg_convert_outargstruc(solution_str,outargstruc_arr);
outargstruc_arr = results.data;
solution_str = results.string;

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2016.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 

